
//----  script file, Cybrid BeachHead
//===========================================

// AUTHORS:  	Slade & Filthy Clyde
// Code stolen happily from Dolf Kooz Maps
$Version = "Version 1.08 - Authors:  FilthyClyde & Slade.  Code happily stolen from"@
           " Dolf Kooz Maps."@
           "  Thanks to Dolf and Andrew Crisp for the research to make this work."@
           "  Thanks also to Sentinal, Orogogus, Dull, Mike the Goad, and the Editing & "@
           "Scripting guys for Sharing The Knowledge.  We are not worthy to tie their"@
           " shoelaces together while they are sleeping...........";

$OVconvoyTech = 1;

$server::TeamDamage = true;

$actionStarted = false;

$maxRange = 3200;
$minRange = 2800;

// how many player are alive at squad drop time
$numLivePlayers = 0;


   
Pilot backupPilot
{
   id = 29;
   
   skill = 0.4;
   accuracy = 0.3;
   aggressiveness = 0.8;
   activateDist = 11000.0;
   deactivateBuff = 12000.0;
   targetFreq = 5.4;
   trackFreq = 2.0;
   fireFreq = 2.0;
   LOSFreq = 0.1;
   orderFreq = 0.2;
};
   

function onMissionLoad()
{


   cdAudioCycle("Purge", "Watching", "Mechsoul"); 


    $textMsg = "Destroy Cybrids, Go to Navs, "@
      "Complete Objectives:"@
      "\n1) Scan the Village & Take Action"@
      "\n2) Destroy any Cybrid Bases you find."@
      "\n3) Try to live and report back."@
      "\nGet to Nav Foxtrot for Extraction\n"@
   "Respawning is allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";
   %history = 
"\n\nDate: 2831. Listen up guys.  A Village here on Earth reports Cybrid activity. "@
"They say the Brids have landed and dug in.  We don't know if this is true.  You are "@
"to infiltrate the area.  Protect the village.  Scout the entire area and wipe out any "@
"Cybrid activity you find.  This is our Home Planet.  If they are here, and you fail, we "@
"are all dead.  Good luck.";



   setGameInfo ($textMsg @ %history);
}


//--------------------------------------------
function onMissionStart()
{
   newFormation( Delta, 0,0,0, -60,-60,0, 60,-45,0, 0,-120,0 ); 
   newFormation( Line,  0,0,0, 0,-40,0, 0,-80,0, 0,-120,0 );

   cdAudioCycle( Purge, Terror, gnash);

   marsSounds();
   windSounds();
   init();

}

//---------------------------------------------
function player::onAdd(%this)                                                                                                                        
{
say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");
}

//--------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

 messagebox (%player, "Check the game info tab for game details");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);


    }


 schedule( "setEnemyNavPointB(" @ %this @ ");", 3 );
function setEnemyNavPointB( %this )
{
  setNavMarker( $navBravo, true, %this );
  
}

//---------------------------------------------
 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
//        schedule ("healObject(" @ %this @ ", -50000);", 3);
        Say(%player,0,"<F5>You're late soldier.   The Sarge is gonna make your life miserable.   Better join your squad quick.   I see pushups in your future.....");
       }
   }

}

//-------------Use these to rotate Nav Points-----
function setNavAlphaON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navAlpha, true, %playerVeh  );
     }
}
//--------------------------------------------------
function setNavCharlieON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navCharlie, true, %playerVeh  );
     }
}
//------------------------------------------------------
function setNavDeltaON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navDelta, true, %playerVeh  );
     }
}
//--------------------------------------------------------
function setNavEchoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navEcho, true, %playerVeh  );
     }
}
//--------------------------------------------------------
function setNavFoxtrotON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navFoxtrot, true, %playerVeh  );
     }
}

//-----------------------------------------------------------------------------
function init()
{

$objective1 = false;
$objective2 = false;
$objective3 = false;
$objective4 = false;

$attackStarted = false;
$buildingsDestroyed = 0;

$navAlpha = "MissionGroup/navPoints/navAlpha";
$navBravo = "MissionGroup/navPoints/navBravo";
$navCharlie = "MissionGroup/navPoints/navCharlie";
$navDelta = "MissionGroup/navPoints/navDelta";
$navEcho = "MissionGroup/navPoints/navEcho";
$navFoxtrot = "MissionGroup/navPoints/navFoxtrot";

$CgenA = "MissionGroup/AlphaBaseR";
$CgenB = "MissionGroup/BravoBaseR";
$CgenC = "MissionGroup/CharlieBaseR";
$CgenD = "MissionGroup/DeltaBaseR";
$CgenE = "MissionGroup/EchoBaseR";

   // when the player nears the action
// MPcheckBoundary( enter, getObjectID ($navAlpha) , 600, onArrivedNavAlpha, 20 );



   MPcheckBoundary( leave, getObjectID ($navAlpha) , 200, onLeaveNavAlphaWarning, 1 );
// MPcheckBoundary( enter, getObjectID ("MissionGroup/impPatrol1/imp1") , 1200, onLeaveNavBravo, 1 );
// moved to leave bravo   MPcheckBoundary( leave, getObjectID ($navBravo) , 1700, turnLooseImps, 1 );



}



//-----------------------------------------------------------------------------
function structure::onDestroyed(%this, %who)
{
//------Bravo Stuff--------
	if (%this == getObjectId( "MissionGroup/BravoBaseR/CgenB" ) )
	{
	say(0, 0, "<F5>Cybrid Base at Bravo Destroyed");
        createbackup();
//        createbackup();
        setNavCharlieON();
      $objective1 = true;
	}
//------Charlie Stuff------
	if (%this == getObjectId( "MissionGroup/CharlieBaseR/CgenC" ) )
	{
	say(0, 0, "<F5>Cybrid Base at Charlie Destroyed");
        createbackup();
//        createbackup();
        setNavDeltaON();
      $objective2 = true;
	}
//------Delta Stuff--------
	if (%this == getObjectId( "MissionGroup/DeltaBaseR/CgenD" ) )
	{
	say(0, 0, "<F5>Cybrid Base at Delta Destroyed");
        createbackup();
//        createbackup();
        setNavEchoON();
      $objective3 = true;
	}
//------Echo Stuff---------
	if (%this == getObjectId( "MissionGroup/EchoBaseR/CgenE" ) )
	{
	say(0, 0, "<F5>Cybrid Base at Echo Destroyed, extraction at Foxtrot");
        createbackup();
//        createbackup();
        setNavFoxtrotON();
      $objective4 = true;
       createDropShip();
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot here:  Taking heavy fire at Foxtrot.  Need help.  Shields critical.\");", 240 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot here:  Still taking fire at Foxtrot.  GET OVER HERE.  HELP ME OR WALK HOME.\");", 270 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot:  Ummm... sir... the shields seem to be holding. You could be over-reacting.  Oh, is that mike open....\");", 300 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot here:  LOAD UP OR I'M BUGGING OUT.  MY MOMMA DIDN'T RAISE ME TO SIT HERE AND GET MY ASS SHOT OFF.\");", 320 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot:  Gee sir, you're getting pretty excited.  Why not take this nice pill the nice nurse wants to give you.  It might help you relax.....\");", 350 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot here:  You guys take whatever time you need.  Gosh, I know you're doing a fine job.....  We're all fine here......\");", 380 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot here:  We are all pretty relaxed here at Foxtrot.  The Pilot is cutting out some really nice paper snowflakes....  I know you will want to check them out when you get here.... \");", 410 );     
       MPcheckBoundary( enter, getObjectID ($navFoxtrot) , 200, onArriveNavFoxtrot, 20 );
	}
//-------Bill & Hillary stuff------
	if (%this == getObjectId( "MissionGroup/AlphaBaseR/Hone" ) )
	{
	say(0, 0, "<F5>Mission objective complete.  Village secured.");
        createbackup();
//        createbackup();
	}
}


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function onArriveNavFoxtrot()
{

 %obj1 = getObjectID ( $navFoxtrot );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavFoxtrot();", 10 );
    }

}


//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{




   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }




  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }

}
//-----------------allow DS to heal--------------------------------------------
function vehicle::onAttacked ( %this, %who )
{
//   if (%this == getObjectId( "$hercD" ) )
     if (%this ==  $hercD )
     {
       healobject ( %this, 5000 );
       healobject ( %this, 5000 );
       healobject ( %this, 5000 );
     }
}


//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  if ( $objective1 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nCybrid Base Destroyed ";


  if ( $objective2 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nCybrid Base Destroyed ";

  if ( $objective3 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nCybrid Base Destroyed ";

  if ( $objective4 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nCybrid Base Destroyed ";



//------------------village--------------

    if ( isGroupDestroyed ( $CgenA ) )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nVillage Secured ";

  if ( %howmany == 5  ) %text = %text @ "\nExcellent work team.";
  messageBox(0, "Mission Completed, " @ %howmany @ " of 5 objectives completed. "@ %text );

  deleteObject($AlphaBase);
  deleteObject($DropPointGroup);
  deleteObject($BravoBase);
  deleteObject($CharlieBase);
  deleteObject($DeltaBase);
  deleteObject($EchoBase);
  deleteObject($navPoints);
  deleteObject($AlphaBaseR);
  deleteObject($BravoBaseR);
  deleteObject($CharlieBaseR);
  deleteObject($DeltaBaseR);
  deleteObject($EchoBaseR);  
  deleteObject($dropShipGroup);
  missionendconditionmet();
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );
  deleteObject($AlphaBase);
  deleteObject($DropPointGroup);
  deleteObject($BravoBase);
  deleteObject($CharlieBase);
  deleteObject($DeltaBase);
  deleteObject($EchoBase);
  deleteObject($navPoints);
  deleteObject($AlphaBaseR);
  deleteObject($BravoBaseR);
  deleteObject($CharlieBaseR);
  deleteObject($DeltaBaseR);
  deleteObject($EchoBaseR);  
  deleteObject($dropShipGroup);
  missionendconditionmet();
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function createDropShip()
{
  $hercD = NewObject( "Drop Ship", Flyer, 130); // terran drop ship

  newObject( "dropShipGroup", SimGroup );
  addToSet( "MissionGroup", "dropShipGroup" );
  addToSet( "MissionGroup/dropShipGroup", $hercD );

  setTeam(%herc, *IDSTR_TEAM_YELLOW);
  setPilotId ($hercD,28);

  addToSet( $cargogroup, $hercD );

  setPosition ($hercD, 17.0635, -1239.05, 494.845 );

// don't let that ship take off!
   order( $hercD, shutdown, True );
}

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
function onLeaveNavAlphaWarning ()
{

   $actionStarted = true;
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
   say (0,0, "<f5>TAC-COM here:  The Cybrids know we're here. We think we were sold out.  Check the Village for evidence.");
   $attackStarted = true;
   createbackup();
//   createbackup();
//   createbackup();


}

//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
function vehicle::onMessage (%this, %message, %_1, %_2, %_3, %_4, %_5, %_6, %_7, %_8, %_9)
{

// have the enemy pick a new target
// attacker can run into buildings
  %who1 = playerManager::vehicleIdToPlayerNum (%this);
  if ( %who1 != 0 ) return;

   %target = pickPlayer ();

   order (%this, attack, %target);
}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 3, %rot);

}

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;

//	if (%t == 1) return "C";
//	if (%t == 2) return "H";
	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{

 $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navAlpha), 3, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 3 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 4 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 4 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 5 );
     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 5 );
     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 5 );
     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 5 );
}

function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 3, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 3, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 2, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 4, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{
 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);

  addToSet(  %thisGroup, %herc );

      %x = %x + 100 ;
      %y = %y + 100 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);

//      if ( RandomInt (1,2) == 1 )
//        {
          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );
//        }
//      else
//        {
//          order ( %thisGroup, guard, $retreatPath );
//        }
    }

//    order (%leadherc, makeleader, true);
//    order ( %thisGroup, formation, Delta );

}




//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 3, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 3, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particluar reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

   dropSquad (%xDrop, %yDrop, %howMany, %squadName);

}

